<script>
    import { layout } from "../svelte_stores/layout_store";
    import { hapi_servers } from "../svelte_stores/hapi_servers";
    import { useQuery } from "@sveltestack/svelte-query";
    import { fetch_json } from "../fetch_json.js";
    import { set_dataset_parameters } from "../svelte_stores/catalog_and_info_store.js";

    import PlotElementHAPIParameterSelector from "./PlotElementHAPIParameterSelector.svelte";
    import PlotElementHAPIFormTiming from "./PlotElementHAPIFormTiming.svelte";
    import RangeWithNumberInput from "../form_components/RangeWithNumberInput.svelte";

    import { Modal } from "flowbite-svelte";
    import { Select, Label } from "flowbite-svelte";
    import { Button, ButtonGroup, Helper, Input } from "flowbite-svelte";
    import {
        Table,
        TableBody,
        TableBodyCell,
        TableBodyRow,
    } from "flowbite-svelte";

    export let i_subplot;
    export let i_plot_element;

    let showCatalog = false;
    let showInfo = false;

    const set_allowed_y_types = function (el) {
        if (el.plot_options.plot_type == "epoch_image") {
            return ["string"];
        } else {
            return ["double", "integer"];
        }
    };

    $: allowed_y_types = set_allowed_y_types(
        $layout.subplots[i_subplot].plot_elements[i_plot_element],
    );

    let subplot, plot_element, server, dataset, catalog_url, info_url;
    $: {
        if ($layout.subplots[i_subplot]) {
            subplot = $layout.subplots[i_subplot];
            if ($layout.subplots[i_subplot].plot_elements[i_plot_element]) {
                plot_element = subplot.plot_elements[i_plot_element];
                server = plot_element.data.server;
                dataset = plot_element.data.dataset;
                catalog_url = server + "/catalog";
                info_url = server + "/info?id=" + dataset;
            }
        }
    }
    // $: server = $layout.subplots[i_subplot].plot_elements[i_plot_element].data.server;
    // $: dataset = $layout.subplots[i_subplot].plot_elements[i_plot_element].data.dataset;

    // Catalog of datasets
    // $: catalog_url = $layout.subplots[i_subplot].plot_elements[i_plot_element].server + '/catalog';
    $: catalog_query = useQuery(["catalog", catalog_url], fetch_json, {
        enabled: typeof server != "undefined",
        staleTime: 86400e3,
    });

    // Set up list of items in catalog to check whether the dataset is in the server's catalog
    // in order to prevent info queries on non-existing datasets
    let catalog_items = [];
    $: {
        if ($catalog_query.isSuccess) {
            catalog_items = $catalog_query.data.catalog.map(
                (catalog_item) => catalog_item.id,
            );
        }
    }
    $: valid_catalog_item = catalog_items.includes(dataset);

    // Info per dataset
    // $: info_url = server + '/info?id=' + $layout.subplots[i_subplot].plot_elements[i_plot_element].data.dataset;
    $: info_query = useQuery(["info", info_url], fetch_json, {
        staleTime: 86400e3,
        enabled: valid_catalog_item,
    });

    $: info_query.setOptions(["info", info_url], fetch_json, {
        staleTime: 86400e3,
        enabled: valid_catalog_item,
    });
</script>

{#if subplot && plot_element}
    <!-- Select a HAPI server -->
    <div class="flex flex-col gap-3">
        <h2>Select data:</h2>
        <Label
            >HAPI server:
            <Select
                items={$hapi_servers}
                value={server}
                prompt="Select a server"
                on:change={(e) => {
                    // To prevent hapi/info requests on datasets that are only defined on the old server
                    //   the dataset and parameter have to be set to undefined first, before the new server
                    //   value is set.
                    $layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.dataset = undefined;
                    $layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.parameter = undefined;
                    $layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.cadence = undefined;
                    $layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.cadence_alternative_datasets_mode = "off";
                    $layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.server = e.target.value;
                }} />
            <Helper
                >{$layout.subplots[i_subplot].plot_elements[i_plot_element].data
                    .server}</Helper>
        </Label>

        <!-- Select a dataset from the catalog -->
        {#if $catalog_query.isIdle}
            <Label
                >Dataset:
                <Select
                    class="bg-red-100"
                    placeholder="First select a HAPI server above..."
                    value=""
                    disabled>
                    <option selected disabled
                        >First select a HAPI server above...</option>
                </Select>
            </Label>
        {:else if $catalog_query.isLoading}
            <Label
                >Dataset:
                <Select
                    class="bg-red-100"
                    placeholder="Loading HAPI server catalog..."
                    value=""
                    disabled>
                    <option selected disabled
                        >Loading HAPI server catalog...</option>
                </Select>
            </Label>
            <Label
                >Time axis parameter:
                <Select
                    class="bg-red-100"
                    value=""
                    placeholder="Loading HAPI server catalog..."
                    disabled>
                    <option value="" selected disabled
                        >Loading HAPI server catalog...</option>
                </Select>
            </Label>
            <Label
                >Y-axis parameter:
                <Select
                    class="bg-red-100"
                    value=""
                    placeholder="Loading HAPI server catalog..."
                    disabled>
                    <option value="" disabled selected
                        >Loading HAPI server catalog...</option>
                </Select>
            </Label>
        {:else if $catalog_query.isError}
            <Label
                >Dataset:
                <Select
                    class="bg-red-500"
                    placeholder="Error loading catalog: {$catalog_query.error}"
                    value=""
                    disabled>
                    <option selected disabled>Error loading catalog.</option>
                </Select>
                <Helper
                    >Error loading catalog: {$catalog_query.error}. Please try
                    again later, or choose another server</Helper>
            </Label>
            <Label
                >Time axis parameter:
                <Select
                    class="bg-red-500"
                    value=""
                    placeholder="Error loading catalog."
                    disabled>
                    <option value="" selected disabled
                        >Error loading catalog...</option>
                </Select>
            </Label>
            <Label
                >Y-axis parameter:
                <Select
                    class="bg-red-500"
                    value=""
                    placeholder="Error loading catalog."
                    disabled>
                    <option value="" disabled selected
                        >Error loading catalog.</option>
                </Select>
            </Label>
        {:else}
            <!-- Catalog query is a success -->
            <Label
                >Dataset:
                <Select
                    placeholder="Select a dataset"
                    value={$layout.subplots[i_subplot].plot_elements[
                        i_plot_element
                    ].data.dataset}
                    on:change={(e) => {
                        // Set the parameter and related variables to an empty value first, before the new dataset
                        //   value is set.
                        $layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].data.parameter = undefined;
                        $layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].data.dataset = e.target.value;
                    }}>
                    {#each $catalog_query.data.catalog as catalog_item}
                        {#if $layout.subplots[i_subplot].plot_elements[i_plot_element].data.dataset == catalog_item.id}
                            <option value={catalog_item.id} selected
                                >{catalog_item.id}</option>
                        {:else}
                            <option value={catalog_item.id}
                                >{catalog_item.id}</option>
                        {/if}
                    {/each}
                    <!-- If the dataset in the layout file is not available in the HAPI server catalog -->
                    {#if !$catalog_query.data.catalog
                        .map((i) => i.id)
                        .includes(dataset)}
                        <option
                            value={$layout.subplots[i_subplot].plot_elements[
                                i_plot_element
                            ].dataset}
                            disabled>{dataset} (not in catalog)</option>
                    {/if}
                </Select>
                {#if typeof $info_query.data != "undefined"}
                    {#if "description" in $info_query.data}
                        <Helper>{$info_query.data["description"]}</Helper>
                    {:else}
                        <Helper
                            >No dataset description available in dataset info.</Helper>
                    {/if}
                {/if}
            </Label>
            {#if typeof dataset == "undefined" || dataset == ""}
                <Label
                    >Time axis parameter:
                    <Select
                        class="bg-black-100"
                        value=""
                        placeholder="First select a dataset above..."
                        disabled>
                        <option value="" selected disabled
                            >First select a dataset above...</option>
                    </Select>
                </Label>
                <Label
                    >Y-axis parameter:
                    <Select
                        class="bg-black-100"
                        value=""
                        placeholder="First select a dataset above..."
                        disabled>
                        <option value="" selected disabled
                            >First select a dataset above...</option>
                    </Select>
                </Label>
            {/if}

            <!-- Select a parameter from the product info -->
            {#if $info_query.isLoading}
                <Label
                    >Time axis parameter:
                    <Select
                        class="bg-red-100"
                        value=""
                        placeholder="Loading HAPI dataset info..."
                        disabled>
                        <option value="" selected disabled
                            >Loading HAPI dataset info...</option>
                    </Select>
                </Label>
                <Label
                    >Y-axis parameter:
                    <Select
                        class="bg-red-100"
                        value=""
                        placeholder="Loading HAPI dataset info..."
                        disabled>
                        <option value="" disabled selected
                            >Loading HAPI dataset info...</option>
                    </Select>
                </Label>
            {:else if $info_query.isError}
                <Label
                    >Time axis parameter:
                    <Select
                        class="bg-red-500"
                        value=""
                        placeholder="Error loading dataset info."
                        disabled>
                        <option value="" selected disabled
                            >Error loading dataset info.</option>
                    </Select>
                </Label>
                <Label
                    >Y-axis parameter:
                    <Select
                        class="bg-red-500"
                        value=""
                        placeholder="Error loading dataset info."
                        disabled>
                        <option value="" disabled selected
                            >Error loading dataset info.</option>
                    </Select>
                    <Helper
                        >Error loading dataset info: {$info_query.error}. Please
                        try again later, or contact the HAPI server maintainer</Helper>
                </Label>
            {:else if $info_query.isSuccess}
                <Label
                    >X-axis (time) parameter:
                    <PlotElementHAPIParameterSelector
                        {i_subplot}
                        {i_plot_element}
                        parameter_type="time_parameter"
                        allowed_types={["isotime"]}
                        placeholder="Select a parameter for the x-coordinate..." />
                </Label>

                <Label
                    >Y-axis parameter:
                    <PlotElementHAPIParameterSelector
                        {i_subplot}
                        {i_plot_element}
                        parameter_type="parameter"
                        allowed_types={allowed_y_types}
                        placeholder="Select a parameter for the y-coordinate..." />
                </Label>

                <!-- Optionally, set the baseline parameter -->
                {#if plot_element.plot_options.plot_type == "area" && plot_element.plot_options.baseline_mode == "parameter"}
                    <Label
                        >Parameter for area plot baseline:
                        <PlotElementHAPIParameterSelector
                            {i_subplot}
                            {i_plot_element}
                            parameter_type="baseline_parameter"
                            allowed_types={["double", "integer"]}
                            placeholder="Select a baseline parameter..." />
                    </Label>
                {/if}

                <!-- Optionally, set the color map parameter -->
                {#if plot_element.plot_options.plot_type == "color_mapped_symbols"}
                    <Label
                        >Parameter for fill color of symbols:
                        <PlotElementHAPIParameterSelector
                            {i_subplot}
                            {i_plot_element}
                            parameter_type="z_parameter"
                            allowed_types={["double", "integer"]}
                            placeholder="Select a parameter for fill color..." />
                    </Label>
                {/if}

                <!-- Optionally, set the color map parameter -->
                {#if plot_element.plot_options.plot_type == "xy_text_annotation"}
                    <Label
                        >Parameter for annotation text:
                        <PlotElementHAPIParameterSelector
                            {i_subplot}
                            {i_plot_element}
                            parameter_type="text_parameter"
                            allowed_types={["string", "double", "integer"]}
                            placeholder="Select a parameter for the annotation text..." />
                    </Label>
                {/if}

                <h2>Timing settings:</h2>
                <Label
                    >Refetch interval (in seconds)
                    <RangeWithNumberInput
                        min={60}
                        max={86400}
                        step={10}
                        bind:value={$layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].data.refetch_interval_seconds} />
                </Label>

                <Label
                    >Zoom detail factor
                    <Helper
                        >The maximum number of points that will be loaded for a
                        dataset is determined by the number of pixels in the
                        graph, multiplied by this factor, and the factor in the
                        global options.</Helper>

                    <RangeWithNumberInput
                        min={0.25}
                        max={4}
                        step={0.125}
                        bind:value={$layout.subplots[i_subplot].plot_elements[
                            i_plot_element
                        ].data.zoom_detail_factor} />
                </Label>

                <!-- <PlotElementHAPIFormCadenceAlternatives
                    {i_subplot}
                    {i_plot_element}
                    catalog_query={$catalog_query}
                    info_query={$info_query} /> -->

                <PlotElementHAPIFormTiming
                    {i_subplot}
                    {i_plot_element}
                    catalog_query={$catalog_query}
                    info_query={$info_query} />
            {/if}
            <!-- End of block for successful catalog query  -->
        {/if}

        <h2>Show HAPI output:</h2>
        <ButtonGroup>
            {#if $catalog_query.isSuccess}
                <Button
                    size="xs"
                    class="w-full"
                    outline
                    on:click={() => (showCatalog = true)}>
                    Catalog
                </Button>
            {:else}
                <Button size="xs" class="w-full" outline disabled>
                    Catalog<br />({$catalog_query.status})
                </Button>
            {/if}
            {#if $info_query.isSuccess}
                <Button
                    size="xs"
                    class="w-full"
                    outline
                    on:click={() => (showInfo = true)}>
                    Info
                </Button>
            {:else}
                <Button size="xs" class="w-full" outline disabled>
                    Info<br />({$info_query.status})
                </Button>
            {/if}
            <!-- <Button size='xs' class='w-full' outline disabled>
            Data
        </Button> -->
        </ButtonGroup>
    </div>
    <!-- flex container -->

    <Modal
        bind:open={showCatalog}
        placement="center"
        size="xl"
        autoclose
        outsideclose>
        <div slot="header">
            <h1 class="text-3xl font-bold">HAPI Catalog</h1>
            <h2 class="text-xl font-bold">{server + "/catalog"}</h2>
        </div>
        <pre class="text-xs">{JSON.stringify(
                $catalog_query.data,
                null,
                2,
            )}</pre>
    </Modal>

    <Modal
        bind:open={showInfo}
        placement="center"
        size="xl"
        autoclose
        outsideclose>
        <div slot="header">
            <h1 class="text-3xl font-bold">HAPI dataset info</h1>
            <h2 class="text-xl font-bold">{server + "/info?id=" + dataset}</h2>
        </div>
        <pre class="text-xs">{JSON.stringify($info_query.data, null, 2)}</pre>
    </Modal>
{/if}

<style>
</style>
